;----------------------------------------------------------------
.286
IDEAL
;----------------------------------------------------------------
GROUP           DGROUP _DATA
;----------------------------------------------------------------
SEGMENT         _DATA PARA PUBLIC 'DATA'
;----------------------------------------------------------------
Old24Ofs        dw 0
Old24Seg        dw 0
;----------------------------------------------------------------
ENDS            _DATA
;----------------------------------------------------------------
SEGMENT         IO_TEXT PARA PUBLIC 'CODE'
;----------------------------------------------------------------
ASSUME          CS:IO_TEXT, DS:DGROUP, ES:NOTHING, SS:DGROUP
;----------------------------------------------------------------
CritErrCode     dw      0
Int24GrabCount  db      0
;----------------------------------------------------------------
PUBLIC          _GrabInt24
PROC            _GrabInt24

                Inc     [cs:Int24GrabCount]

                Cmp     [cs:Int24GrabCount], 1
                Ja      @@Exit

                Mov     ax, 03524h
                Int     021h
                Mov     [Old24Ofs], bx
                Mov     [Old24Seg], es

                Push    ds

                Push    cs
                Pop     ds
                Mov     dx, offset MyInt24
                Mov     ax, 02524h
                Int     021h

                Pop     ds

@@Exit:         Retf
;---------------
MyInt24:        Mov     ax, di
                Xor     ah, ah
                And     al, al
                Jnz     @@Skip
                Mov     al, 0FFh
@@Skip:         Mov     [cs:CritErrCode], ax
                Mov     al, 3
                Iret

ENDP            _GrabInt24
;----------------------------------------------------------------
PUBLIC          _ReleaseInt24
PROC            _ReleaseInt24

                Dec     [cs:Int24GrabCount]
                Jnz     @@Exit

                Push    ds
                Lds     dx, [DWORD PTR Old24Ofs]
                Mov     ax, 02524h
                Int     021h
                Pop     ds

@@Exit:         Retf

ENDP            _ReleaseInt24
;----------------------------------------------------------------
PUBLIC          _CheckError
ALIGN 4
PROC            _CheckError

                Pushf
                Cmp     [cs:CritErrCode], 0
                Jne     @@CriticalError
                Popf
;---------------
                Jc      @@DOSError
                Retf
;---------------
@@DOSError:     Add     ax, 100
                Stc
                Retf
;---------------
@@CriticalError:
                Xor     ax, ax
                XChg    ax, [cs:CritErrCode]
                Popf
                Stc
                Retf

ENDP            _CheckError
;----------------------------------------------------------------
ENDS            IO_TEXT
;----------------------------------------------------------------
END

